IO::Stapled - Crystal 1.5.0

# class IO::Stapled

- IO::Stapled
- IO
- Reference
- Object

##
Overview

This class staples together two unidirectional `IO`s to form a single, bidirectional `IO`.

Example (loopback):

    io = IO::Stapled.new(*IO.pipe)
    io.puts "linus"
    io.gets # => "linus"

Most methods simply delegate to the underlying `IO`s.

##
Defined in:

io/stapled.cr

##
Constructors

- .new(reader : IO, writer : IO, sync_close : Bool = false)

  Creates a new `IO::Stapled` which reads from reader and writes to writer.

##
Class Method Summary

- .pipe(read_blocking : Bool = false, write_blocking : Bool = false, &)

  Creates a pair of bidirectional pipe endpoints connected with each other and passes them to the given block.

- .pipe(read_blocking : Bool = false, write_blocking : Bool = false) : Tuple(self, self)

  Creates a pair of bidirectional pipe endpoints connected with each other and returns them in a `Tuple`.

##
Instance Method Summary

- #close : Nil

  Closes this `IO`.

- #closed? : Bool

  Returns `true` if this `IO` is closed.

- #flush : self

  Flushes `writer`.

- #gets(delimiter : Char, limit : Int, chomp = false) : String?

  Gets a string from `reader`.

- #peek : Bytes?

  Peeks into `reader`.

- #read(slice : Bytes) : Int32

  Reads a slice from `reader`.

- #read_byte : UInt8?

  Reads a single byte from `reader`.

- #skip(bytes_count : Int) : Nil

  Skips `reader`.

- #skip_to_end : Nil

  Skips `reader`.

- #sync_close=(sync_close : Bool)

  If `#sync_close?` is `true`, closing this `IO` will close the underlying `IO`s.

- #sync_close? : Bool

  If `#sync_close?` is `true`, closing this `IO` will close the underlying `IO`s.

- #write(slice : Bytes) : Nil

  Writes a slice to `writer`.

- #write_byte(byte : UInt8) : Nil

  Writes a byte to `writer`.

### Instance methods inherited from class `IO`

<<(obj) : self <<, close close, closed? : Bool closed?, each_byte(&) : Nil
each_byte each_byte, each_char(&) : Nil
each_char each_char, each_line(*args, **options, &block : String -> ) : Nil
each_line(*args, **options) each_line, encoding : String encoding, flush flush, getb_to_end : Bytes getb_to_end, gets(limit : Int, chomp = false) : String?
gets(delimiter : Char, limit : Int, chomp = false) : String?
gets(delimiter : Char, chomp = false) : String?
gets(delimiter : String, chomp = false) : String?
gets(chomp = true) : String? gets, gets_to_end : String gets_to_end, peek : Bytes? peek, pos pos, pos=(value) pos=, print(obj : _) : Nil
print(*objects : _) : Nil print, printf(format_string, args : Array | Tuple) : Nil
printf(format_string, *args) : Nil printf, puts(string : String) : Nil
puts(obj : _) : Nil
puts : Nil
puts(*objects : _) : Nil puts, read(slice : Bytes) read, read_at(offset, bytesize, & : IO -> ) read_at, read_byte : UInt8? read_byte, read_bytes(type, format : IO::ByteFormat = IO::ByteFormat::SystemEndian) read_bytes, read_char : Char? read_char, read_fully(slice : Bytes) : Int32 read_fully, read_fully?(slice : Bytes) : Int32? read_fully?, read_line(*args, **options) : String read_line, read_string(bytesize : Int) : String read_string, read_utf8(slice : Bytes) read_utf8, read_utf8_byte : UInt8? read_utf8_byte, rewind rewind, seek(offset, whence : Seek = Seek::Set) seek, set_encoding(encoding : String, invalid : Symbol? = nil) : Nil set_encoding, skip(bytes_count : Int) : Nil skip, skip_to_end : Nil skip_to_end, tell tell, tty? : Bool tty?, write(slice : Bytes) : Nil write, write_byte(byte : UInt8) : Nil write_byte, write_bytes(object, format : IO::ByteFormat = IO::ByteFormat::SystemEndian) : Nil write_bytes, write_string(slice : Bytes) : Nil write_string, write_utf8(slice : Bytes) : Nil write_utf8

### Class methods inherited from class `IO`

copy(src, dst, limit : Int) : Int64
copy(src, dst) : Int64 copy, pipe(read_blocking = false, write_blocking = false) : Tuple(IO::FileDescriptor, IO::FileDescriptor)
pipe(read_blocking = false, write_blocking = false, &) pipe, same_content?(stream1 : IO, stream2 : IO) : Bool same_content?

### Instance methods inherited from class `Reference`

==(other : self)
==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup, hash(hasher) hash, initialize initialize, inspect(io : IO) : Nil inspect, object_id : UInt64 object_id, pretty_print(pp) : Nil pretty_print, same?(other : Reference) : Bool
same?(other : Nil) same?, to_s(io : IO) : Nil to_s

### Constructor methods inherited from class `Reference`

new new

### Instance methods inherited from class `Object`

! : Bool !, !=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, as(type : Class) as, as?(type : Class) as?, class class, dup dup, hash(hasher)
hash hash, in?(collection : Object) : Bool
in?(*values : Object) : Bool in?, inspect(io : IO) : Nil
inspect : String inspect, is_a?(type : Class) : Bool is_a?, itself itself, nil? : Bool nil?, not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, responds_to?(name : Symbol) : Bool responds_to?, tap(&) tap, to_json(io : IO) : Nil
to_json : String to_json, to_pretty_json(indent : String = " ") : String
to_pretty_json(io : IO, indent : String = " ") : Nil to_pretty_json, to_s(io : IO) : Nil
to_s : String to_s, to_yaml(io : IO) : Nil
to_yaml : String to_yaml, try(&) try, unsafe_as(type : T.class) forall T unsafe_as

### Class methods inherited from class `Object`

from_json(string_or_io, root : String)
from_json(string_or_io) from_json, from_yaml(string_or_io : String | IO) from_yaml

##
Constructor Detail

def self.new(reader : IO, writer : IO, sync_close : Bool = false) #

Creates a new `IO::Stapled` which reads from reader and writes to writer.

##
Class Method Detail

def self.pipe(read_blocking : Bool = false, write_blocking : Bool = false, &) #

Creates a pair of bidirectional pipe endpoints connected with each other and passes them to the given block.

Both endpoints and the underlying `IO`s are closed after the block (even if `#sync_close?` is `false`).

def self.pipe(read_blocking : Bool = false, write_blocking : Bool = false) : Tuple(self, self) #

Creates a pair of bidirectional pipe endpoints connected with each other and returns them in a `Tuple`.

##
Instance Method Detail

def close : Nil #

Closes this `IO`.

If `#sync_close?` is `true`, it will also close the underlying `IO`s.

def closed? : Bool #

Returns `true` if this `IO` is closed.

Underlying `IO`s might have a different status.

def flush : self #

Flushes `writer`.

def gets(delimiter : Char, limit : Int, chomp = false) : String? #

Gets a string from `reader`.

def peek : Bytes? #

Peeks into `reader`.

def read(slice : Bytes) : Int32 #

Reads a slice from `reader`.

def read_byte : UInt8? #

Reads a single byte from `reader`.

def skip(bytes_count : Int) : Nil #

Skips `reader`.

def skip_to_end : Nil #

Skips `reader`.

def sync_close=(sync_close : Bool) #

If `#sync_close?` is `true`, closing this `IO` will close the underlying `IO`s.

def sync_close? : Bool #

If `#sync_close?` is `true`, closing this `IO` will close the underlying `IO`s.

def write(slice : Bytes) : Nil #

Writes a slice to `writer`.

def write_byte(byte : UInt8) : Nil #

Writes a byte to `writer`.